Ruby - Bug #11285

Net::HTTP should handle content-coding with case-insensitive
06/18/2015 11:38 PM - littlechu (Andy Chu)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.0.0: REQUIRED, 2.1: DONE, 2.2:
DONE

Description
When Ruby Net::HTTP sent a request. It by default set the content to be compress with header: Accept-Encoding

But if server return with content-encoding = GZIP (or any case other then all lower case) it will not tread the body as compressed.
According to HTTP 1.1 spec, Content-Encoding should be value used by content-coding, and the value of content-coding should be

case-insensitive
content-coding: http://www.w3.org/Protocols/rfc2616/rfc2616-sec3.html#sec3.5

I think simply change the code here: https:/github.com/ruby/ruby/blob/trunk/lib/net/http/response.rb#L. 253

from

case self['content-encoding']

to

case self['content-encoding'].downcase

should work

Associated revisions

Revision 84de36c74831bb6420fcd3c224fc515380€28350 - 06/29/2015 07:14 AM - naruse (Yui NARUSE)

¢ lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@51061 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 84de36¢7 - 06/29/2015 07:14 AM - naruse (Yui NARUSE)

e lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@51061 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 3b90cf70d17b5441a83b7ccb1aalff2e8b2f5bbc - 08/10/2015 04:47 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 51061,51063,51091: [Backport #11285]

* lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

* test/net/http/test_httpresponse.rb
(HTTPResponseTest#test_read_body_content_encoding deflate_uppercase) :
fix a failure without zlib.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 2@51522 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3b90cf70 - 08/10/2015 04:47 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 51061,51063,51091: [Backport #11285]
http://www.w3.org/Protocols/rfc2616/rfc2616-sec3.html#sec3.5
https://github.com/ruby/ruby/blob/trunk/lib/net/http/response.rb#L253

* lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

* test/net/http/test_httpresponse.rb
(HTTPResponseTest#test_read_body_content_encoding deflate_uppercase) :
fix a failure without zlib.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 2@51522 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 9580200f7da99a5d1e2¢c3b35354b4972d1be9ea5 - 08/17/2015 07:50 AM - U.Nakamura
merge revision(s) 51061,51063,51091: [Backport #11285]

* lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

* test/net/http/test_httpresponse.rb
(HTTPResponseTest#test_read_body_content_encoding deflate_uppercase) :
fix a failure without zlib.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51602 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 9580200f - 08/17/2015 07:50 AM - U.Nakamura
merge revision(s) 51061,51063,51091: [Backport #11285]

* lib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

* test/net/http/test_httpresponse.rb
(HTTPResponseTest#test_read_body_content_encoding deflate_uppercase) :

fix a failure without zlib.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51602 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/29/2015 07:15 AM - naruse (Yui NARUSE)
- Status changed from Open to Closed

Applied in changeset r51061.

e |ib/net/http/response.rb (inflater): CONTENT_ENCODING can be upper
case. [ruby-core:69670] [Bug #11285] patched by Andy Chu

#2 - 06/29/2015 04:52 PM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED

#3 - 06/29/2015 04:53 PM - nagachika (Tomoyuki Chikanaga)

memo: r51063 is required too.

#4 - 08/10/2015 04:47 PM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED to 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: DONE

r51061, r51063 and r51091 were backported into ruby_2_2 branch at r51522.

#5 - 08/17/2015 07:50 AM - usa (Usaku NAKAMURA)
- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: DONE to 2.0.0: REQUIRED, 2.1: DONE, 2.2: DONE

ruby_2 1 r51602 merged revision(s) 51061,51063,51091.
